#version 330 core
out vec4 FragColor;

in vec2 fsUV;
in float fsTime;

uniform sampler2DMS colorBufferTextureMS;

void main()
{
	ivec2 size = textureSize(colorBufferTextureMS);
	ivec2 uv = ivec2(size * fsUV);
    vec3 color0 = texelFetch(colorBufferTextureMS, uv, 0).rgb;
    vec3 color1 = texelFetch(colorBufferTextureMS, uv, 1).rgb;
    vec3 color2 = texelFetch(colorBufferTextureMS, uv, 2).rgb;
    vec3 color3 = texelFetch(colorBufferTextureMS, uv, 3).rgb;

    vec3 color = (color0 + color1 + color2 + color3) * 0.25;

    float t = abs(step(color.g, 0.5) + step(color.b, 0.5)) - 1.0;

    color = mix(color, vec3(1,0,0), t);

    FragColor = vec4(color.rgb, 1.0f);
}